package com.example.demo;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class MuffinController {

    @Autowired
    private MuffinRepository muffinRepository;

    @GetMapping("/muffins")
    public ResponseEntity<Iterable<Muffin>> index() {
        return new ResponseEntity<>(this.muffinRepository.findAll(), HttpStatus.OK);
    }

    @GetMapping("/bakers")
    public ResponseEntity<Muffin> show(@PathVariable Long id) {
        return new ResponseEntity<>(this.muffinRepository.findOne(id), HttpStatus.OK);
    }

    @GetMapping("/bakers")
    public ResponseEntity<Muffin> create(@PathVariable Muffin muffin) {
        return new ResponseEntity<>(this.muffinRepository.save(muffin), HttpStatus.CREATED);
    }

    @GetMapping("/bakers")
    public ResponseEntity<Muffin> update(@PathVariable Long id, Muffin muffin) {
        Muffin foundMuffin = muffinRepository.findOne(id);
        foundMuffin.setFlavor(muffin.getFlavor());

        return new ResponseEntity<>(this.muffinRepository.save(foundMuffin), HttpStatus.OK);
    }

    @GetMapping("/bakers")
    public ResponseEntity<Boolean> destroy(@PathVariable Long id) {
        this.muffinRepository.delete(id);
        return new ResponseEntity<>(true, HttpStatus.OK);
    }

}

